
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Evgeniy Uvarov"
#property link      "http://"

extern double Lot=0.1;

extern bool usehightolowcorrelation = false;

extern int    threshold1=20; 
extern int    threshold2=50;
extern int    threshold3=120;

extern string time = "Hours";
extern int    StartHour = 0;
extern int    StopHour  = 24;

extern string stops = "Stops";
extern int TP = 280;
extern int SL = 280;

extern string NH_set = "NeuralHedgeSettings";
extern string SubSymbol = "AUDUSD";
extern int Pair_Correlation = 0;
extern int Period_Ratio = 72;
extern int Order_MainPair = -1;
extern double threshold = 0.0;
extern double Factor_Threshold = 0.0;

extern string slugeb = "service";
extern int slip=3;
extern int MaxAttempts=5;
extern int MAGIC=873670;


int buy=0,sell=0,round, last;
double lotstep, lastprice, lasttpbuy, lasttpsell, lastslbuy, lastslsell;
static int prevtime = 0;
int sig = 0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   lotstep = MarketInfo(Symbol(), MODE_LOTSTEP);
   round = MathAbs(MathLog(lotstep) / MathLog(10.0)) + 0.5;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if (iTime(Symbol(), 0, 0) != prevtime)
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~Start OnceOfBar
   prevtime = iTime(Symbol(),0,0);

double koef;

if(usehightolowcorrelation)
 {
  double cur = iHigh( NULL, PERIOD_D1, 0) - iLow( NULL, PERIOD_D1, 0);
  double sub = iHigh( SubSymbol, PERIOD_D1, 0) - iLow( SubSymbol, PERIOD_D1, 0);
  if(cur>sub) koef = cur/sub;
   else koef = sub/cur;
 }
 else koef = 1;

string symb = "";
double th = iCustom(NULL, 0, "NeutralHedge osc_v3[1]_forbot", SubSymbol, Pair_Correlation, Period_Ratio, Order_MainPair, threshold, Factor_Threshold, 2, 1)/koef;
double th2 = iCustom(NULL, 0, "NeutralHedge osc_v3[1]_forbot", SubSymbol, Pair_Correlation, Period_Ratio, Order_MainPair, threshold, Factor_Threshold, 2, 2)/koef;
//+++ CURRENT +++ 
 symb = Symbol();
 countOpenPosition(symb, MAGIC);
 
 if(th<0 && sell>0) CloseAll(symb, OP_SELL, MAGIC);
 if(th>0 && buy>0)  CloseAll(symb, OP_BUY, MAGIC);
 
 if(th<0 && Hour()>=StartHour && Hour()<StopHour) 
  {
   if(th2>-threshold1 && th<=-threshold1 && buy == 0) Buy(symb, Lot, SL, TP, symb+" NH", slip, MAGIC, MaxAttempts, Blue);
   if(th2>-threshold2 && th<=-threshold2 && buy <  2) Buy(symb, Lot, SL, TP, symb+" NH", slip, MAGIC, MaxAttempts, Blue);
   if(th2>-threshold3 && th<=-threshold3 && buy <  3) Buy(symb, Lot, SL, TP, symb+" NH", slip, MAGIC, MaxAttempts, Blue);
  }
 if(th>0 && Hour()>=StartHour && Hour()<StopHour) 
  {
   if(th2<threshold1 && th>=threshold1 && sell == 0) Sell(symb, Lot, SL, TP, symb+" NH", slip, MAGIC, MaxAttempts, Red);
   if(th2<threshold2 && th>=threshold2 && sell <  2) Sell(symb, Lot, SL, TP, symb+" NH", slip, MAGIC, MaxAttempts, Red);
   if(th2<threshold3 && th>=threshold3 && sell <  3) Sell(symb, Lot, SL, TP, symb+" NH", slip, MAGIC, MaxAttempts, Red);
  }
//+++ CURRENT +++ 

//+++ SubSymbol +++ 
 symb = SubSymbol;
 countOpenPosition(symb, MAGIC);
 
 if(th>0 && sell>0) CloseAll(symb, OP_SELL, MAGIC);
 if(th<0 && buy>0)  CloseAll(symb, OP_BUY, MAGIC);
 
 if(th>0 && Hour()>=StartHour && Hour()<StopHour) 
  {
   if(th2<threshold1 && th>=threshold1 && buy == 0) Buy(symb, Lot, SL, TP, symb+" NH", slip, MAGIC, MaxAttempts, Blue);
   if(th2<threshold2 && th>=threshold2 && buy <  2) Buy(symb, Lot, SL, TP, symb+" NH", slip, MAGIC, MaxAttempts, Blue);
   if(th2<threshold3 && th>=threshold3 && buy <  3) Buy(symb, Lot, SL, TP, symb+" NH", slip, MAGIC, MaxAttempts, Blue);
  }
 if(th<0 && Hour()>=StartHour && Hour()<StopHour) 
  {
   if(th2>-threshold1 && th<=-threshold1 && sell == 0) Sell(symb, Lot, SL, TP, symb+" NH", slip, MAGIC, MaxAttempts, Red);
   if(th2>-threshold2 && th<=-threshold2 && sell <  2) Sell(symb, Lot, SL, TP, symb+" NH", slip, MAGIC, MaxAttempts, Red);
   if(th2>-threshold3 && th<=-threshold3 && sell <  3) Sell(symb, Lot, SL, TP, symb+" NH", slip, MAGIC, MaxAttempts, Red);
  }
//+++ SubSymbol +++ 

}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~End OnceOfBar
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int waitIfBusy() 
{   
   for (int Yx = 0; IsTradeContextBusy() && Yx < 50; Yx++) Sleep(125);   
   if (Yx >= 50) Print("    ", DoubleToStr(25 * Yx / 1000, 2), " ");
   else if (Yx > 0) Print("    ", DoubleToStr(25 * Yx / 1000, 2), " ");   
   return (Yx);   
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void countOpenPosition(string symb, int MAGIC)
{
buy=0;sell=0;

for (int q=-1; q<OrdersTotal()+1; q++)
  {
  if (OrderSelect(q,SELECT_BY_POS,MODE_TRADES)==true)
    {
    if(OrderSymbol()!=symb || OrderMagicNumber()!=MAGIC)continue;
      {
       if(OrderType()==OP_BUY)      buy++;
       if(OrderType()==OP_SELL)     sell++;
      }
    }
  }
return;
} 
//+------------------------------------------------------------------+
void CloseAll(string symb, int type, int MAGIC)
  {
int cmd = 0;
  for (int i=OrdersTotal()+1;i>=0; i--)
    {
    if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
      {
      if (OrderSymbol()==symb && OrderMagicNumber()==MAGIC)
      {//**
      RefreshRates();
 double Point_ = MarketInfo(symb, MODE_POINT);
 double Digits_ = MarketInfo(symb, MODE_DIGITS);
      if(OrderType()==OP_BUY && OrderType()==type)
       {
        cmd = 0;
           for (int j = 0; cmd < 1 && j < MaxAttempts; j++)
            {
             waitIfBusy();
             cmd = OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(symb, MODE_BID), Digits_),slip, Blue);
             if(cmd<0) {Sleep(2000); RefreshRates();}
            }   
       }
      if(OrderType()==OP_SELL && OrderType()==type)
       {
        cmd = 0;
           for (j = 0; cmd < 1 && j < MaxAttempts; j++)
            {
             waitIfBusy();
             cmd = OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(symb, MODE_ASK), Digits_),slip, Red);
             if(cmd<0) {Sleep(2000); RefreshRates();}
            }   
       }
      }//**
      }
    }
}
//+------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
void Buy(string symb, double Lot, int SL, int TP, string com, int slip, int MagicNumber, int MaxAttempts, color c = CLR_NONE)
{
 int ticket=0, cmd = 0;
 double tp = 0, sl = 0;
 double Point_ = MarketInfo(symb, MODE_POINT);
 double Digits_ = MarketInfo(symb, MODE_DIGITS);
         for (int j = 0; ticket < 1 && j < MaxAttempts; j++)
         {
            waitIfBusy();
            ticket = OrderSend(symb, OP_BUY, Lot, NormalizeDouble(MarketInfo(symb, MODE_ASK), Digits_), slip, 0, 0, com, MagicNumber, 0, c);
            if(ticket<0) {Sleep(2000); RefreshRates();}
         }   
         if(ticket<0) 
         {
            Print(": ",GetLastError()); 
         }
         if (ticket>0 && (TP>0 || SL>0))//
          {
           for (j = 0; cmd < 1 && j < MaxAttempts; j++)
            {
             waitIfBusy();
             OrderSelect(ticket, SELECT_BY_TICKET);
             if(TP>0) tp = OrderOpenPrice() + TP*Point_;
             if(SL>0) sl = OrderOpenPrice() - SL*Point_;
             cmd = OrderModify(ticket, OrderOpenPrice(), sl, tp, 0, Blue);
             if(cmd<0) {Sleep(2000); RefreshRates();}
            }   
          }
}
//+------------------------------------------------------------------+
void Sell(string symb, double Lot, int SL, int TP, string com, int slip, int MagicNumber, int MaxAttempts, color c = CLR_NONE)
{
 int ticket=0, cmd = 0;
 double tp = 0, sl = 0;
 double Point_ = MarketInfo(symb, MODE_POINT);
 double Digits_ = MarketInfo(symb, MODE_DIGITS);
         for (int j = 0; ticket < 1 && j < MaxAttempts; j++)
         {
            waitIfBusy();
            ticket = OrderSend(symb, OP_SELL, Lot, NormalizeDouble(MarketInfo(symb, MODE_BID), Digits_), slip, 0, 0, com, MagicNumber, 0, c);
            if(ticket<0) {Sleep(2000); RefreshRates();}
         }   
         if(ticket<0) 
         {
            Print(": ",GetLastError()); 
         }
         if (ticket>0 && (TP>0 || SL>0))//
          {
           for (j = 0; cmd < 1 && j < MaxAttempts; j++)
            {
             waitIfBusy();
             OrderSelect(ticket, SELECT_BY_TICKET);
             if(TP>0) tp = OrderOpenPrice() - TP*Point_;
             if(SL>0) sl = OrderOpenPrice() + SL*Point_;
             cmd = OrderModify(ticket, OrderOpenPrice(), sl, tp, 0, Red);
             if(cmd<0) {Sleep(2000); RefreshRates();}
            }   
          }
}
//+------------------------------------------------------------------+

